//----------------------------------------------------------------------//
// Sound Bubbles	CtH[										//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>

#include <Vcl.HtmlHelpViewer.hpp>
#pragma link "Vcl.HTMLHelpViewer"

#include "usr_wic.h"
#include "usrfunc.h"
#include "MidiPort.h"
#include "SndDlg.h"
#include "PrmDlg.h"
#include "DsgnDlg.h"
#include "MidRcBox.h"
#include "About.h"
#include "MainForm.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TSbblMainForm *SbblMainForm;
TIniFile *IniFile;

bubble_prm BBprm;		//Ãp[^

//---------------------------------------------------------------------------
__fastcall TSbblMainForm::TSbblMainForm(TComponent* Owner) : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::FormCreate(TObject *Sender)
{
	FRMprm.bgimg = new Graphics::TBitmap();

	//wv̏
	Application->HelpFile = ChangeFileExt(Application->ExeName, ".CHM");

	//INIt@Cǂݍ
	IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
	int vno = IniFile->ReadInteger("General","version",0);
	if (vno<get_VersionNo()) {
		IniFile->WriteInteger("General","version", get_VersionNo());	//o[WԍXV
	}

	UnicodeString sct = "Parameters";
	BBprm.volume	   = IniFile->ReadInteger(sct,"Volume", 	 90);
	BBprm.count 	   = IniFile->ReadInteger(sct,"Count", 	 	 12);
	BBprm.min_speed    = IniFile->ReadInteger(sct,"min_speed",   4);
	BBprm.max_speed    = IniFile->ReadInteger(sct,"max_speed",	 15);
	BBprm.best_dist    = IniFile->ReadInteger(sct,"best_dist",	 50);
	BBprm.tone_dist    = IniFile->ReadInteger(sct,"tone_dist",   3);
	BBprm.copyWait	   = IniFile->ReadString( sct,"copyWait",	 0.3 ).ToDouble();
	BBprm.centerWait   = IniFile->ReadString( sct,"centerWait",  0.1 ).ToDouble();
	BBprm.mouseWait    = IniFile->ReadString( sct,"mouseWait",   0.2 ).ToDouble();
	BBprm.oppositeWait = IniFile->ReadString( sct,"oppositeWait",0.18).ToDouble();
	BBprm.acceleration = IniFile->ReadString( sct,"acceleration",1.2 ).ToDouble();
	BBprm.front_view   = IniFile->ReadBool(	  sct,"front_view",  true);
	BBprm.joinV 	   = IniFile->ReadBool(	  sct,"joinV", 		 false);
	BBprm.joinH 	   = IniFile->ReadBool(	  sct,"joinH",		 false);
	BBprm.size		   = IniFile->ReadInteger(sct,"bubble_size", 8);

	sct = "Design";
	FRMprm.col_background	 = (TColor)IniFile->ReadInteger(sct,"Background",clBlack);
	FRMprm.col_center_ring	 = (TColor)IniFile->ReadInteger(sct,"CenterRing",clGray);
	FRMprm.col_mouse_ring	 = (TColor)IniFile->ReadInteger(sct,"MouseRing", clLime);
	for (int i=0;i<MAX_BB_GROUP;i++) {
		FRMprm.col_group_ring[i] = (TColor)IniFile->ReadInteger(sct,"GroupRing"+IntToStr(i+1), clTeal);
		FRMprm.col_nrm_brs[i]	 = (TColor)IniFile->ReadInteger(sct,"NrmBubbleB"+IntToStr(i+1),clNavy);
		FRMprm.col_nrm_pen[i]	 = (TColor)IniFile->ReadInteger(sct,"NrmBubbleP"+IntToStr(i+1),clBlue);
		FRMprm.col_act_brs[i]	 = (TColor)IniFile->ReadInteger(sct,"ActBubbleB"+IntToStr(i+1),clPurple);
		FRMprm.col_act_pen[i]	 = (TColor)IniFile->ReadInteger(sct,"ActBubbleP"+IntToStr(i+1),clFuchsia);
	}
	FRMprm.enable_bgimg 	 = (bool)IniFile->ReadInteger(sct,"EnableBgImage",0);
	FRMprm.stretch_bgimg	 = (bool)IniFile->ReadInteger(sct,"StretchBgImage",0);
	FRMprm.bgimg_file		 = IniFile->ReadString(sct,"BgImage", EmptyStr);
	if (FileExists(FRMprm.bgimg_file))
		WIC_load_image(FRMprm.bgimg_file, FRMprm.bgimg);
	else
		FRMprm.bgimg_file = EmptyStr;
	FRMprm.hide_titlebar     = (bool)IniFile->ReadInteger(sct,"HideTitlebar",0);

	//A𐶐
	for (int i=0;i<MAX_BB_GROUP;i++) {
		BB[i] = new Bubbles(this);
		BB[i]->set_prm(&BBprm);
		BB[i]->set_color(
			FRMprm.col_nrm_pen[i], FRMprm.col_nrm_brs[i], FRMprm.col_act_pen[i], FRMprm.col_act_brs[i]);
	}
	//ւ𐶐
	for (int i=0;i<MAX_BB_GROUP;i++) {
		GRing[i] = new TShape(this);
		GRing[i]->Parent	   = this;
		GRing[i]->Shape 	   = stCircle;
		GRing[i]->Pen->Color   = FRMprm.col_group_ring[i];
		GRing[i]->Brush->Style = bsClear;
	}
	MRing = new TShape(this);
	MRing->Parent		= this;
	MRing->Shape		= stCircle;
	MRing->Pen->Color	= FRMprm.col_center_ring;
	MRing->Brush->Style = bsClear;

	MouseON = false;

	//MIDȈ
	sct = "Sound";
	MidiPort = new TMidiPort();
	MidiPort->DevNum = IniFile->ReadInteger(sct,"driver",0);
	MidiPort->OutOpen();
	//ʂݒ
	for (int i=0;i<MAX_MIDICHN;i++) MidiPort->SetVolume(i, BBprm.volume);
	//Fݒ
	MidiPort->SetPrg(0, IniFile->ReadInteger(sct,"prg_00",  9)-1);
	MidiPort->SetPrg(1, IniFile->ReadInteger(sct,"prg_01",  9)-1);
	MidiPort->SetPrg(2, IniFile->ReadInteger(sct,"prg_02", 11)-1);
	MidiPort->SetPrg(3, IniFile->ReadInteger(sct,"prg_03", 33)-1);
	MidiPort->SetPrg(4, IniFile->ReadInteger(sct,"prg_04", 33)-1);
	MidiPort->SetPrg(5, IniFile->ReadInteger(sct,"prg_05",116)-1);
	for (int i=6;i<MAX_MIDICHN;i++) {
		UnicodeString kstr = UnicodeString().sprintf(_T("prg_%02x"), i);
		int pn = IniFile->ReadInteger(sct, kstr, 1);
		MidiPort->SetPrg(i, pn-1);
	}
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::FormShow(TObject *Sender)
{
	Color = FRMprm.col_background;
	UnicodeString sct	= "General";
    WindowState 	= (TWindowState)IniFile->ReadInteger(sct,"WinState",wsNormal);
	Width			= IniFile->ReadInteger(sct,"WinWidth",	640);
    Height			= IniFile->ReadInteger(sct,"WinHeight",	480);
	Left			= IniFile->ReadInteger(sct,"WinLeft",(Screen->Width-Width)/2);
    Top 			= IniFile->ReadInteger(sct,"WinTop", (Screen->Height-Height)/2);
	SoundDlg->Left	= IniFile->ReadInteger(sct,"SoundDlgLeft",	Left+50);
	SoundDlg->Top	= IniFile->ReadInteger(sct,"SoundDlgTop", 	Top+50);
	ParamDlg->Left	= IniFile->ReadInteger(sct,"ParamDlgLeft",	Left+100);
	ParamDlg->Top	= IniFile->ReadInteger(sct,"ParamDlgTop", 	Top+100);
	DesignDlg->Left = IniFile->ReadInteger(sct,"DesignDlgLeft",	Left+150);
	DesignDlg->Top  = IniFile->ReadInteger(sct,"DesignDlgTop", 	Top+150);
	MidRecBox->Left = IniFile->ReadInteger(sct,"MidRecBoxLeft",	Left+200);
	MidRecBox->Top	= IniFile->ReadInteger(sct,"MidRecBoxTop", 	Top+200);
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	//ݒ̕ۑ
	UnicodeString sct = "General";
	if (WindowState==wsMinimized) WindowState = wsNormal;
	IniFile->WriteInteger(sct,"WinState",	WindowState);
	if (WindowState==wsMaximized) WindowState = wsNormal;
	IniFile->WriteInteger(sct,"WinLeft",	Left);
	IniFile->WriteInteger(sct,"WinTop",		Top);
	IniFile->WriteInteger(sct,"WinWidth",	Width);
	IniFile->WriteInteger(sct,"WinHeight",	Height);
   	IniFile->WriteInteger(sct,"SoundDlgLeft",	SoundDlg->Left);
   	IniFile->WriteInteger(sct,"SoundDlgTop",	SoundDlg->Top);
	IniFile->WriteInteger(sct,"ParamDlgLeft",	ParamDlg->Left);
    IniFile->WriteInteger(sct,"ParamDlgTop",	ParamDlg->Top);
	IniFile->WriteInteger(sct,"DesignDlgLeft",	DesignDlg->Left);
    IniFile->WriteInteger(sct,"DesignDlgTop",	DesignDlg->Top);
	IniFile->WriteInteger(sct,"MidRecBoxLeft",	MidRecBox->Left);
	IniFile->WriteInteger(sct,"MidRecBoxTop",	MidRecBox->Top);

	sct = "Design";
	IniFile->WriteInteger(sct,"Background",		(int)FRMprm.col_background);
	IniFile->WriteInteger(sct,"CenterRing",		(int)FRMprm.col_center_ring);
	IniFile->WriteInteger(sct,"MouseRing", 		(int)FRMprm.col_mouse_ring);
	for (int i=0;i<MAX_BB_GROUP;i++) {
		IniFile->WriteInteger(sct,"GroupRing"+IntToStr(i+1), (int)FRMprm.col_group_ring[i]);
		IniFile->WriteInteger(sct,"NrmBubbleB"+IntToStr(i+1), (int)FRMprm.col_nrm_brs[i]);
		IniFile->WriteInteger(sct,"NrmBubbleP"+IntToStr(i+1), (int)FRMprm.col_nrm_pen[i]);
		IniFile->WriteInteger(sct,"ActBubbleB"+IntToStr(i+1), (int)FRMprm.col_act_brs[i]);
		IniFile->WriteInteger(sct,"ActBubbleP"+IntToStr(i+1), (int)FRMprm.col_act_pen[i]);
	}
    IniFile->WriteString(sct, "BgImage",		FRMprm.bgimg_file);
	IniFile->WriteInteger(sct,"EnableBgImage",	(int)FRMprm.enable_bgimg);
	IniFile->WriteInteger(sct,"StretchBgImage",	(int)FRMprm.stretch_bgimg);
	IniFile->WriteInteger(sct,"HideTitlebar",	(int)FRMprm.hide_titlebar);

	sct = "Parameters";
	IniFile->WriteInteger(sct,"Volume", 	 BBprm.volume);
	IniFile->WriteInteger(sct,"Count",		 BBprm.count);
	IniFile->WriteInteger(sct,"min_speed",	 BBprm.min_speed);
	IniFile->WriteInteger(sct,"max_speed",	 BBprm.max_speed);
	IniFile->WriteInteger(sct,"best_dist",	 BBprm.best_dist);
	IniFile->WriteInteger(sct,"tone_dist",	 BBprm.tone_dist);
	IniFile->WriteString( sct,"copyWait",    FloatToStr(BBprm.copyWait));
	IniFile->WriteString( sct,"centerWait",  FloatToStr(BBprm.centerWait));
	IniFile->WriteString( sct,"mouseWait",   FloatToStr(BBprm.mouseWait));
	IniFile->WriteString( sct,"oppositeWait",FloatToStr(BBprm.oppositeWait));
	IniFile->WriteString( sct,"acceleration",FloatToStr(BBprm.acceleration));
	IniFile->WriteBool(	  sct,"front_view",  BBprm.front_view);
	IniFile->WriteBool(	  sct,"joinV",		 BBprm.joinV);
	IniFile->WriteBool(	  sct,"joinH",		 BBprm.joinH);
	IniFile->WriteInteger(sct,"bubble_size", BBprm.size);

	sct = "Sound";
	IniFile->WriteInteger(sct,"driver", MidiPort->DevNum);
	for (int i=0;i<MAX_MIDICHN;i++) {
		UnicodeString kstr = UnicodeString().sprintf(_T("prg_%02x"), i);
		IniFile->WriteString(sct, kstr, MidiPort->ChnPrg[i]+1);
	}

	IniFile->UpdateFile();

	//MIDIfoCX
	MidiPort->OutClose();
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::FormDestroy(TObject *Sender)
{
	delete IniFile;
	delete MidiPort;
    delete FRMprm.bgimg;

	for (int i=0;i<MAX_BB_GROUP;i++) delete BB[i];
}

//---------------------------------------------------------------------------
// ʔwi̕`
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::FormPaint(TObject *Sender)
{
	if (FRMprm.enable_bgimg) {
		try {
			if (!FRMprm.bgimg->Empty) {
				if (FRMprm.stretch_bgimg==1) {
					//O`ɍ킹
					Canvas->StretchDraw(ClientRect, FRMprm.bgimg);
				}
				else {
					//ׂĕ~l߂
					for(int x=0; x<ClientWidth; x+=FRMprm.bgimg->Width) {
						for(int y=0; y<ClientHeight; y+=FRMprm.bgimg->Height) {
							Canvas->Draw(x,y, FRMprm.bgimg);
						}
					}
				}
			}
		}
	    catch(...) {
			FRMprm.enable_bgimg = false;
		}
	}
}

//---------------------------------------------------------------------
// ő剻␳(^Cgo[ƃj[B)
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::WmGetMinMaxInfo(TWMGetMinMaxInfo &Msg ){
	TForm::Dispatch(&Msg);
	if (FRMprm.hide_titlebar) {
		RECT rc;
		::GetWindowRect(GetDesktopWindow(),&rc);
		::AdjustWindowRect(&rc, WS_OVERLAPPEDWINDOW, TRUE);
		Msg.MinMaxInfo->ptMaxSize.y		 = rc.bottom-rc.top;
		Msg.MinMaxInfo->ptMaxTrackSize.y = rc.bottom-rc.top;
		Msg.MinMaxInfo->ptMaxPosition.y	 = rc.top;
	}
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::FormResize(TObject *Sender)
{
	Repaint();
}


//---------------------------------------------------------------------------
//j[
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::ExitItemClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::SoundItemClick(TObject *Sender)
{
	SoundDlg->Show();
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::ParameterItemClick(TObject *Sender)
{
	ParamDlg->Show();
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::DesignItemClick(TObject *Sender)
{
	DesignDlg->Show();
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::AboutItemClick(TObject *Sender)
{
 	AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::ContentsItemClick(TObject *Sender)
{
	Application->HelpShowTableOfContents();
}

//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::PopupMenu1Popup(TObject *Sender)
{
	PopRestoreItem->Visible = (FRMprm.hide_titlebar && (WindowState==wsMaximized));
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::PopRestoreItemClick(TObject *Sender)
{
	WindowState = wsNormal;
}

//---------------------------------------------------------------------------
//^C}[
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::Timer1Timer(TObject *Sender)
{
	MidiPort->UpdateRecCount();

	//Έʒu̐ݒ
	BB[0]->stt.oppositeX = (BB[1]->stt.centerX+BB[2]->stt.centerX)/2;
	BB[0]->stt.oppositeY = (BB[1]->stt.centerY+BB[2]->stt.centerY)/2;
	BB[1]->stt.oppositeX = (BB[0]->stt.centerX+BB[2]->stt.centerX)/2;
	BB[1]->stt.oppositeY = (BB[0]->stt.centerY+BB[2]->stt.centerY)/2;
	BB[2]->stt.oppositeX = (BB[0]->stt.centerX+BB[1]->stt.centerX)/2;
	BB[2]->stt.oppositeY = (BB[0]->stt.centerY+BB[1]->stt.centerY)/2;

	int mx, my;
	if (MouseON) {
		mx = BB[0]->stt.mouseX;
		my = BB[0]->stt.mouseY;
	}
	else {
		mx = my = 0;
		for (int i=0;i<MAX_BB_GROUP;i++) {
			mx += BB[i]->stt.centerX;
			my += BB[i]->stt.centerY;
		}
		mx /= MAX_BB_GROUP;
		my /= MAX_BB_GROUP;
		for (int i=0;i<MAX_BB_GROUP;i++) {
			BB[i]->stt.mouseX = mx;
			BB[i]->stt.mouseY = my;
		}
	}

	for (int i=0;i<MAX_BB_GROUP;i++) {
		BB[i]->move();
		int w = 200*BB[i]->stt.loudness;
		GRing[i]->Width  = w;
		GRing[i]->Height = w;
		GRing[i]->Left	 = BB[i]->stt.centerX-GRing[i]->Width/2;
		GRing[i]->Top	 = BB[i]->stt.centerY-GRing[i]->Height/2;
	}

	//}EXց^S
	MRing->Pen->Color = MouseON ? FRMprm.col_mouse_ring : FRMprm.col_center_ring;
	int w = 50*(BB[0]->stt.loudness + BB[1]->stt.loudness + BB[2]->stt.loudness)+4;
	MRing->Width  = w;
	MRing->Height = w;
	MRing->Left   = mx - MRing->Width/2;
	MRing->Top	  = my - MRing->Height/2;

	//TEh
	for (int n=0;n<MAX_BB_GROUP;n++) {
		Bubbles *bsp = BB[n];
		int p = floor(127.0*bsp->stt.centerX/ClientWidth);
		//Aꉹ
		for (int i=0;i<BBprm.count;i++) {
			bubble *bp = &bsp->bb[i];
			tn_rec *tp = &bp->tone;
			if (tp->req) {
				MidiPort->SetPan(n, p);
				MidiPort->KeyOn(n, tp->key,tp->vel);
				bp->cp->Pen->Color	 = FRMprm.col_act_pen[n];
				bp->cp->Brush->Color = FRMprm.col_act_brs[n];
				tp->req = 0;
			}
			else if (tp->tcnt>0) {
				if ((--tp->tcnt)==0) {
					MidiPort->KeyOn(n,tp->key,0);
					bp->cp->Pen->Color	 = FRMprm.col_nrm_pen[n];
					bp->cp->Brush->Color = FRMprm.col_nrm_brs[n];
				}
			}
		}
		//Ǒŉ
		for (int i=0;i<MAX_TONES;i++) {
			tn_rec *tp = &bsp->tn[i];
			if (tp->req) {
				MidiPort->SetPan(n+3, p);
				MidiPort->KeyOn(n+3,tp->key,tp->vel);
				tp->req = 0;
			}
			else if (tp->tcnt>0) {
				if ((--tp->tcnt)==0)
					MidiPort->KeyOn(n+3,tp->key,0);
			}
		}
	}
}

//---------------------------------------------------------------------------
// }EX
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	MouseON = Shift.Contains(ssLeft);
	for (int i=0;i<MAX_BB_GROUP;i++) {
		BB[i]->stt.mouseX = X;
		BB[i]->stt.mouseY = Y;
	}
}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::FormMouseMove(TObject *Sender, TShiftState Shift, int X,	int Y)
{
	if (MouseON) {
		for (int i=0;i<MAX_BB_GROUP;i++) {
			BB[i]->stt.mouseX = X;
			BB[i]->stt.mouseY = Y;
		}
	}

}
//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::FormMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	MouseON = false;
}

//---------------------------------------------------------------------------
void __fastcall TSbblMainForm::MidiRecItemClick(TObject *Sender)
{
	MidRecBox->Show();
}
//---------------------------------------------------------------------------

