//----------------------------------------------------------------------//
// MIDIL^c[{bNX												//
//																		// 
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>

#include "MidiPort.h"
#include "MidRcBox.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMidRecBox *MidRecBox;

//---------------------------------------------------------------------------
__fastcall TMidRecBox::TMidRecBox(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMidRecBox::FormShow(TObject *Sender)
{
	MidiPort->Recorded = false;
}
//---------------------------------------------------------------------------
void __fastcall TMidRecBox::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	if (MidiPort->Recording) MidiPort->RecStop();
	if (MidiPort->Recorded)  SaveRec();
}

//---------------------------------------------------------------------------
void __fastcall TMidRecBox::Timer1Timer(TObject *Sender)
{
	if (MidiPort->Recording) {
		int c = MidiPort->RecCount/4;
		int s = c/10;	c %= 10;
		int h = s/3600; s -= h*3600;
		int m = s/60;   s -= m*60;
		CountEdit->Text = UnicodeString().sprintf(_T(" %02u:%02u:%02u.%1u"), h,m,s,c);
	}
	else
		CountEdit->Text = MidiPort->Recorded ? " L^" : " ҋ@";
}

//---------------------------------------------------------------------------
void __fastcall TMidRecBox::RecActionExecute(TObject *Sender)
{
	if (!MidiPort->Recording) {
		//L^Jn
		if (Sender!=NULL) MidiPort->RecStart(RECINI_ALL);
	}
	else {
		//L^~Eۑ
		MidiPort->RecStop();
		SaveRec();
	}
}
//---------------------------------------------------------------------------
void __fastcall TMidRecBox::RecActionUpdate(TObject *Sender)
{
	if (MidiPort->Recording) {
		RecBtn->Caption = "";
		RecBtn->Font->Color = clBlack;
	}
	else {
		RecBtn->Caption = "";
		RecBtn->Font->Color = clRed;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMidRecBox::SaveRec()
{
	SaveDialog1->Filter 	= "MIDIt@C (*.mid)|*.MID";
	SaveDialog1->DefaultExt = "MID";
	SaveDialog1->FileName	= "*.mid";
	if (SaveDialog1->Execute()) {
		if (!MidiPort->RecSave(SaveDialog1->FileName)) {
			Application->MessageBox(
				_T("ۑł܂ł"), _T("x"), MB_OK+MB_ICONWARNING);
		}
	}
}
//---------------------------------------------------------------------------

