//----------------------------------------------------------------------//
// MIDI|[gNX														//
//																		//
//----------------------------------------------------------------------//
#ifndef midiportH
#define midiportH

//---------------------------------------------------------------------------
#include <vcl.h>

#include <mmsystem.h>
#include <stdio.h>

//---------------------------------------------------------------------------
#define MAX_MIDICHN 16
#define MAX_TONE 32

struct tone_rec {
	int flag;
	int chn;
	int key;
	int vel;
	int tcnt;
	int ownr;
};

//MIDICxg (L^p)
struct evt_rec {
	int  count;		//JEgl

	int	 delta[4];	//f^E^C
	int  deltan;	//f^E^C̃oCg

	BYTE Status;
	BYTE Data1;
	BYTE Data2;
	bool running;	//jOXe[^X
	int  datan;		//f[^oCg
	BYTE *ExData;	//sysexpf[^ւ̃|C^
};

//RecStart(iflag)
//L^Jn̏vtO
#define RECINI_PRG 0x0001
#define RECINI_VOL 0x0002
#define RECINI_PAN 0x0004
#define RECINI_ALL (RECINI_PRG|RECINI_VOL|RECINI_PAN)


//---------------------------------------------------------------------------
class TMidiPort {
private:
	HMIDIOUT hmo;

public:
	int DevNum;
	int ChnPrg[MAX_MIDICHN];
	int ChnVol[MAX_MIDICHN];
	int ChnPan[MAX_MIDICHN];

	tone_rec tone[MAX_TONE];

	FILE *RecStream;
	bool Recording;			//L^
	bool Recorded;			//L^ς
	int  RecCount;			//L^pJEgl
	int  StartCount;
	TList *RecData;			//MIDICxg̋L^Xg

	TMidiPort();
	~TMidiPort();

	int  __fastcall GetDevMax();
	MMRESULT __fastcall OutOpen();
	void __fastcall OutClose();
	UINT __fastcall sendMsg(BYTE bStatus, BYTE bData1,  BYTE bData2);

	int  __fastcall GetPrg(int chn);
	void __fastcall SetPrg(int chn, int prg);
	void __fastcall SetVolume(int chn, int vol);
	void __fastcall SetPan(int chn, int pan);
	void __fastcall KeyOn(int chn, int key, int vel);
	void __fastcall AllNoteOff(int chn);
	void __fastcall BendSensibility(int chn, int v);
	void __fastcall PitchBend(int chn, int bnd);
	void __fastcall PitchBendL(int chn, int bnd);

	int  __fastcall cre_ton(int c, int k, int v,int t, int o);
	void __fastcall upd_ton();
	void __fastcall stp_ton();
	int  __fastcall get_tns(int o);
	void __fastcall bnd_ton(int id,int bnd);

	void __fastcall TMidiPort::UpdateRecCount();
	void __fastcall WriteRecValue(int v, int w);
	void __fastcall RecStart(int iflag);
	void __fastcall RecStop();
	bool __fastcall RecSave(UnicodeString fname);
	void __fastcall RecEnd();
};

//---------------------------------------------------------------------------
extern const char GM_Instrument[128][32];
extern TMidiPort *MidiPort;
//---------------------------------------------------------------------------
#endif
