//----------------------------------------------------------------------//
// Sound Bubbles	TEhݒ_CAO								//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include "MidiPort.h"
#include "MainForm.h"
#include "SndDlg.h"

//---------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TSoundDlg *SoundDlg;

//---------------------------------------------------------------------
__fastcall TSoundDlg::TSoundDlg(TComponent* AOwner) : TForm(AOwner)
{
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::FormCreate(TObject *Sender)
{
	MIDIOUTCAPS mcp;
	for (int i=0;i<MidiPort->GetDevMax();i++) {
		if (::midiOutGetDevCaps(i,&mcp,sizeof(mcp))==MMSYSERR_NOERROR)
			MidiOutDevCombo->Items->Add(mcp.szPname);
		else
			MidiOutDevCombo->Items->Add("<none>");
	}
	for (int i=0;i<128;i++) {
		Prg11ComboBox->Items->Add(GM_Instrument[i]);
		Prg21ComboBox->Items->Add(GM_Instrument[i]);
		Prg31ComboBox->Items->Add(GM_Instrument[i]);
		Prg12ComboBox->Items->Add(GM_Instrument[i]);
		Prg22ComboBox->Items->Add(GM_Instrument[i]);
		Prg32ComboBox->Items->Add(GM_Instrument[i]);
	}
}
//---------------------------------------------------------------------
void __fastcall TSoundDlg::FormShow(TObject *Sender)
{
	MidiOutDevCombo->ItemIndex = MidiPort->DevNum;
	Prg11ComboBox->ItemIndex = MidiPort->ChnPrg[0];
	Prg21ComboBox->ItemIndex = MidiPort->ChnPrg[1];
	Prg31ComboBox->ItemIndex = MidiPort->ChnPrg[2];
	Prg12ComboBox->ItemIndex = MidiPort->ChnPrg[3];
	Prg22ComboBox->ItemIndex = MidiPort->ChnPrg[4];
	Prg32ComboBox->ItemIndex = MidiPort->ChnPrg[5];
	VolumeLabel->Caption  = BBprm.volume;
	VolTrackBar->Position = BBprm.volume;
}

//---------------------------------------------------------------------------
void __fastcall TSoundDlg::MidiOutDevComboChange(TObject *Sender)
{
	MidiPort->OutClose();
	MidiPort->DevNum = MidiOutDevCombo->ItemIndex;
	MidiPort->OutOpen();
	for (int i=0;i<MAX_MIDICHN;i++) {
		MidiPort->SetPrg(i, MidiPort->ChnPrg[i]);
		MidiPort->SetVolume(i, BBprm.volume);
	}
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::PrgChgChange(TObject *Sender)
{
	TComboBox *p = (TComboBox*)Sender;
	MidiPort->SetPrg(p->Tag, p->ItemIndex);
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::VolTrackBarChange(TObject *Sender)
{
	BBprm.volume = VolTrackBar->Position;
    VolumeLabel->Caption = BBprm.volume;
	for (int i=0;i<MAX_MIDICHN;i++) MidiPort->SetVolume(i, BBprm.volume);
}
//---------------------------------------------------------------------------

