//----------------------------------------------------------------------//
// Sound Bubbles	Bubbles NX										//
//																		//
//----------------------------------------------------------------------//
#include <stdlib.h>
#include "bubbles.h"

//----------------------------------------------------------------------
Bubbles::Bubbles(TForm* Owner)
{
	//ftHg̃p[^
	prm.count		  = 0;
	prm.copyWait	  = 0;
	prm.centerWait	  = 0;
	prm.mouseWait	  = 0;
	prm.oppositeWait  = 0;
	prm.max_speed	  = 10;
	prm.min_speed	  = 4;
	prm.acceleration  = 1.2;
	prm.best_dist	  = 50;
	prm.tone_dist	  = 3;
	prm.front_view	  = 1;
	prm.joinV		  = 0;
	prm.joinH		  = 0;
	prm.size		  = 8;

	pf = Owner;

	for (int i=0;i<MAX_BUBBLES;i++) {
		//AShape
		bb[i].cp = new TShape(pf);
		bb[i].cp->Parent	   = (TWinControl*)pf;
		bb[i].cp->Tag		   = i;
		bb[i].cp->Shape 	   = stCircle;
		bb[i].cp->Width 	   = prm.size;
		bb[i].cp->Height	   = prm.size;
		bb[i].cp->Left		   = bb[i].X = random(pf->ClientWidth-20)+10;
		bb[i].cp->Top		   = bb[i].Y = random(pf->ClientHeight-20)+10;
		bb[i].cp->Pen->Color   = clBlue;
		bb[i].cp->Brush->Color = clNavy;
		bb[i].cp->Visible	   = false;

		//Ȁ
		bb[i].vX = random(10)+1;
		bb[i].vY = random(10)+1;
		nrm_vector(&bb[i].vX, &bb[i].vY);

		bb[i].speed = random(prm.max_speed);
		if (bb[i].speed<prm.min_speed) bb[i].speed = prm.min_speed;

		bb[i].tone.chn	= 0;
		bb[i].tone.req	= 0;
		bb[i].tone.tcnt = 0;
	}

	for (int i=0;i<MAX_TONES;i++) {
		tn[i].chn  = 1;
		tn[i].req  = 0;
		tn[i].tcnt = 0;
	}

	stt.mouseON = false;
}

//----------------------------------------------------------------------
//xNg̐K
void Bubbles::nrm_vector(double *x, double *y )
{
	double xx = *x;
	double yy = *y;
	double s  = sqrt(xx*xx+yy*yy);

	if (s>0) {
   		*x = xx/s;
   		*y = yy/s;
	}
	else {
		//0̏ꍇ̓_ɏ
		switch (random(4)) {
		case 0: *x = 1;  *y = 0;  break;
		case 1: *x = 0;  *y = 1;  break;
		case 2: *x = -1; *y = 0;  break;
		case 3: *x = 0;  *y = -1; break;
		}
	}
}

//----------------------------------------------------------------------
//aIȉ
int Bubbles::harm_key(int k,int h)
{
	int itv = k%12;
	int oct = h/12;
	int ret;

	switch (random(5)) {
	case 0: ret = 12; break;	//8
	case 1: ret = 4;  break;	//3M
	case 2: ret = 5;  break;	//4
	case 3: ret = 7;  break;	//5
	case 4: ret = 11; break;	//7M
	}
	ret = oct*12+itv+ret;
	while (ret>127) ret -= 12;
	return ret;
}

//----------------------------------------------------------------------
//p[^ݒ肵ĖA̎pXV
void Bubbles::set_prm(bubble_prm *pp)
{
	prm = *pp;	//p[^Rs[
	for (int i=0;i<MAX_BUBBLES;i++) {
		bool vflag = (i<prm.count);
		if (bb[i].cp->Visible != vflag) {
			bb[i].cp->Visible = vflag;
			if (vflag) {
				//o
				bb[i].cp->Left = bb[i].X = random(pf->ClientWidth-20)+10;
				bb[i].cp->Top  = bb[i].Y = random(pf->ClientHeight-20)+10;
			}
		}
		bb[i].cp->Width   = prm.size;
		bb[i].cp->Height  = prm.size;
	}
}
//----------------------------------------------------------------------
//Fݒ
void Bubbles::set_color(TColor n_p, TColor n_b, TColor a_p, TColor a_b)
{
	for (int i=0;i<MAX_BUBBLES;i++) {
		if (bb[i].tone.tcnt>0) {
			bb[i].cp->Pen->Color   = a_p;
			bb[i].cp->Brush->Color = a_b;
		}
		else {
			bb[i].cp->Pen->Color   = n_p;
			bb[i].cp->Brush->Color = n_b;
		}
	}
}

//----------------------------------------------------------------------
//A̓XV
void Bubbles::move()
{
	int last_key = -1;

	//Q̒S߂
	int cx = 0;
	int cy = 0;
	for (int i=0;i<prm.count;i++) {
		cx += bb[i].X;
		cy += bb[i].Y;
	}
	stt.centerX = cx/prm.count;
	stt.centerY = cy/prm.count;

	//X̖Ȁ
	for (int i=0;i<prm.count;i++) {
		//center vector
		double vcx = stt.centerX-bb[i].X;
		double vcy = stt.centerY-bb[i].Y;
		bb[i].cS = 1-sqrt(vcx*vcx+vcy*vcy)/pf->ClientWidth;
		if (bb[i].cS<0) bb[i].cS = 0;
		nrm_vector(&vcx, &vcy);

		//mouse vector
		double vmx = stt.mouseX-bb[i].X;
	    double vmy = stt.mouseY-bb[i].Y;
		bb[i].mS = 1-sqrt(vmx*vmx+vmy*vmy)/pf->ClientWidth;
		if (bb[i].mS<0) bb[i].mS = 0;
		nrm_vector(&vmx,&vmy);

		//opposite vector
		double vox = stt.oppositeX-bb[i].X;
        double voy = stt.oppositeY-bb[i].Y;
		bb[i].oS = 1-sqrt(vox*vox+voy*voy)/pf->ClientWidth;
		if (bb[i].oS<0) bb[i].oS = 0;
		nrm_vector(&vox, &voy);

		//ł߂A
		int mn = 9999;
		int n  = -1;
		double p = 0;	//
		for (int j=0;j<prm.count;j++) {
			if (j!=i) {
				double x1 = bb[j].X - bb[i].X;
				double y1 = bb[j].Y - bb[i].Y;
				p = bb[i].vX*x1 + bb[i].vY*y1;
				if ((p>0) || (prm.front_view==0)) {
					double s = sqrt(x1*x1 + y1*y1);
					if (s<mn) {
						mn = s;
						n  = j;
					}
				}
			}
		}

		if (n!=-1) {
			if (mn<prm.tone_dist) {
				//Aꉹ
	            if (bb[i].tone.tcnt==0) {
					bb[i].tone.key = floor(0x5f*bb[i].mS);
					if (last_key!=-1) bb[i].tone.key = harm_key(last_key,bb[i].tone.key);
		            bb[i].tone.vel	= floor(100*bb[i].cS);
					bb[i].tone.tcnt = floor(4 + 40*bb[i].speed/prm.max_speed);
					bb[i].tone.req	= 1;
					last_key = bb[i].tone.key;
				}
	            if (bb[n].tone.tcnt==0) {
		            bb[n].tone.key	= harm_key(bb[i].tone.key,bb[i].tone.key);
		            bb[n].tone.vel	= floor(100*bb[n].cS);
					bb[n].tone.tcnt = floor(4 + 40*bb[n].speed/prm.max_speed);
		            bb[n].tone.req	= 1;
					last_key = bb[n].tone.key;
		        }
	        }

			//̒
			if (mn<prm.best_dist) {
				if		(p>0) bb[i].speed /= prm.acceleration;
				else if (p<0) bb[i].speed *= prm.acceleration;
			}
			if (bb[i].speed>prm.max_speed) bb[i].speed = prm.max_speed;
			if (bb[i].speed<prm.min_speed) bb[i].speed = prm.min_speed;
		}

		//̐isxNg߂
		if (n!=-1) {
			bb[i].vX += (prm.copyWait*bb[n].vX);
			bb[i].vY += (prm.copyWait*bb[n].vY);
		}
		bb[i].vX += (prm.centerWait*vcx  +prm.mouseWait*vmx -prm.oppositeWait*vox);
		bb[i].vY += (prm.centerWait*vcy  +prm.mouseWait*vmy -prm.oppositeWait*voy);
		nrm_vector(&bb[i].vX, &bb[i].vY);
	}

	for (int i=0;i<prm.count;i++) {
		//ʒuXV
		bb[i].X += bb[i].speed*bb[i].vX;
		bb[i].Y += bb[i].speed*bb[i].vY;

		int touch = 0;
		if (prm.joinH) {
		//Eڍ̏ꍇ
			if ((bb[i].vX > 0) && (bb[i].X > pf->ClientWidth))
				//E[ɒB
				bb[i].X = -prm.size;
			else if ((bb[i].vX < 0) && ((bb[i].X+prm.size) < 0))
				//[ɒB
				bb[i].X = pf->ClientWidth;
		}
		else {
		//Eǂ̏ꍇ
			if ((bb[i].vX > 0) && ((bb[i].X+prm.size) > pf->ClientWidth)) {
				//E[ɏՓ
				bb[i].vX = -bb[i].vX*prm.acceleration;
				touch = 1;
			}
			else if ((bb[i].vX < 0) && (bb[i].X < 0)) {
				//[ɏՓ
				bb[i].vX = -bb[i].vX*prm.acceleration;
				touch = 1;
			}
		}

		if (prm.joinV) {
		//㉺ڍ̏ꍇ
			if ((bb[i].vY > 0) && (bb[i].Y > pf->ClientHeight))
				//[ɒB
				bb[i].Y = -prm.size;
			else if ((bb[i].vY < 0) && ((bb[i].Y+prm.size) < 0))
				//[ɒB
				bb[i].Y = pf->ClientHeight;
		}
		else {
		//㉺ǂ̏ꍇ
			if ((bb[i].vY > 0) && ((bb[i].Y+prm.size) > pf->ClientHeight)) {
				//[ɏՓ
				bb[i].vY = -bb[i].vY*prm.acceleration;
				touch = 1;
			}
			else if ((bb[i].vY < 0) && (bb[i].Y < 0)) {
				//[ɏՓ
				bb[i].vY = -bb[i].vY*prm.acceleration;
				touch = 1;
			}
		}

		//\ʒuXV
		bb[i].cp->Left = bb[i].X;
		bb[i].cp->Top  = bb[i].Y;

		if (touch) {
			//Փˉ
			for (int j=0;j<MAX_TONES;j++) {
				if (tn[j].tcnt==0) {
		            tn[j].key = 0x1f + random(12);
					if (last_key!=-1) tn[j].key = harm_key(last_key, tn[j].key);
		            tn[j].vel  = 100*bb[i].speed/prm.max_speed;
					tn[j].tcnt = random(10)+5;
					tn[j].req  = 1;
					last_key = tn[j].key;
					break;
				}
			}
		}
	}

	//status
	stt.loudness	= 0;
	stt.ave_key 	= 0;
	stt.keyon_count = 0;
	for (int i=0;i<prm.count;i++) {
		if (bb[i].tone.tcnt>0) {
			stt.loudness += bb[i].tone.vel;
			stt.ave_key  += bb[i].tone.key;
			stt.keyon_count++;
		}
	}
	stt.loudness = stt.loudness/prm.count/127;
	if (stt.keyon_count>0)
		stt.ave_key = stt.ave_key/stt.keyon_count/127;
	else
		stt.ave_key = 0;
}
//----------------------------------------------------------------------
