//----------------------------------------------------------------------//
// Sound Bubbles	Bubbles NX										//
//																		//
//----------------------------------------------------------------------//
#ifndef BubblesH
#define BubblesH

//---------------------------------------------------------------------------
#include <math.h>
#include <vcl.h>

//---------------------------------------------------------------------------
#define MAX_BUBBLES  64
#define MAX_TONES    32

//---------------------------------------------------------------------------
struct tn_rec {
	int req;
	int chn;
	int key;
	int vel;
	int tcnt;
};

struct bubble {
	int X,Y;
	double mS,cS,oS;
	double vX,vY,speed;
	TShape* cp;
	tn_rec tone;
};

struct bubble_prm {
	int volume;
	int count;
	double best_dist;
	double max_speed;
	double min_speed;
	double acceleration;
	double copyWait;
	double centerWait;
	double mouseWait;
	double oppositeWait;
	double tone_dist;
	bool front_view;
	bool joinV;
	bool joinH;
	int size;
};

struct status {
	bool mouseON;
	int  centerX,centerY;
	int  mouseX,mouseY;
	int  oppositeX, oppositeY;
	double loudness;
	double ave_key;
	int keyon_count;
};

class Bubbles {
private:
	void nrm_vector(double *x, double *y );
	int harm_key(int k,int h);

public:
	TForm* pf;
	bubble bb[MAX_BUBBLES];
	bubble_prm prm;
	status stt;
	tn_rec tn[MAX_TONES];

	Bubbles(TForm* Owner);

	void set_prm(bubble_prm *pp);
	void set_color(TColor n_p, TColor n_b, TColor a_p, TColor a_b);
	void move();
	void update();
};
//---------------------------------------------------------------------------
#endif
